# sqite_adapter.rb
#
# This will go away, since we don't currently use sqlite3.
#require 'sqlite3'

module FTLTools
  module Adapters
    class Sqlite
      def start( source = {} )
        @source = source
      end

      def items_from_options( num = 1, unique = true )
        # Needs a way to allow non unique.
        # With the "ORDER BY RANDOM() LIMIT #{num}" statement,
        #   if num > count, returns all data, but no duplicates.

        data          = Array.new
        data_store    = @source[:data_store]
        table         = @source[:table]
        db            = SQLite3::Database.open data_store
        count_query   = db.prepare "SELECT COUNT(*) from #{table}"
        count_query.close if count_query

        query         = db.prepare "SELECT * FROM #{table} ORDER BY RANDOM() LIMIT #{num}"
        result        = query.execute
        result.each   { |r|
          data << r[0]
        }
        query.close if query
        db.close
        data
      end
    end
  end
end
