# crew.rb
#
#

module FTLTools
  # Storage for each member of the crew
  class Crew
   
    attr_reader :roster
     
    def initialize
      @roster = Hash.new
    end 
    
    def add(data)
      if data[:team]
        add_team(data) unless @roster[data[:team]]
        @roster[data[:team]] << data[:person]
      else
        @roster[data[:role]] = data[:person]
      end
    end

    def add_team(data)
      @roster[data[:team]] = Array.new
    end

  end
end
